from datetime import datetime
from mpl_toolkits.mplot3d import Axes3D
from matplotlib import rcParams
rcParams['font.family'] = 'serif'
rcParams['font.sans-serif'] = 'Times'
rcParams['font.size'] = 8
from matplotlib import cm
from matplotlib.ticker import LinearLocator,ScalarFormatter, FormatStrFormatter, MaxNLocator
import matplotlib.pyplot as plt
import matplotlib.gridspec as gridspec
from datetime import datetime
import sys
import os
from numpy import *
from scipy import *
import scipy.io as sio

import shutil

###########################################
def function(x1,x2):

    f = (x1)**2.0 + 2*x2**2.0
    f1  = 2.*x1 
    f2  = 4.*x2   
    
    return f,f1,f2    
 
###########################################    

x1  = 1.
x2  = 1.

x1_grid     =   arange(-2.0, 2.0, 0.1)
x2_grid     =   arange(-2.0, 2.0, 0.1)

x1_grid, x2_grid =   meshgrid(x1_grid,x2_grid)

f,f1,f2     =   function(x1_grid,x2_grid)         

#####

ms_1        =   3
ms_2        =   5

plt.figure()
plt.subplots_adjust(hspace=0.2,wspace=0.5)

sbplt_3D    = plt.subplot2grid((4,5),(0,0), colspan=3, rowspan=3, projection='3d')
sbplt_top   = plt.subplot2grid((4,5),(3,0), colspan=1, rowspan=1, projection='3d')
sbplt_front = plt.subplot2grid((4,5),(3,1), colspan=1, rowspan=1, projection='3d')
sbplt_side  = plt.subplot2grid((4,5),(3,2), colspan=1, rowspan=1, projection='3d')
sbplt_text  = plt.subplot2grid((4,5),(0,3), colspan=2, rowspan=1)  
    
sbplt_3D.plot_surface(x1_grid,x2_grid,f,rstride=2,cstride=2,linewidth=0,cmap=cm.coolwarm,alpha=0.4)
sbplt_top.plot_surface(x1_grid,x2_grid,f,rstride=2,cstride=2,linewidth=0,cmap=cm.coolwarm,alpha=0.5)
sbplt_front.plot_surface(x1_grid,x2_grid,f,rstride=2,cstride=2,linewidth=0,cmap=cm.coolwarm,alpha=0.5)
sbplt_side.plot_surface(x1_grid,x2_grid,f,rstride=2,cstride=2,linewidth=0,cmap=cm.coolwarm,alpha=0.5) 

#Gradienty
#################################

#analyticky
f_anal,df1_anal,df2_anal      =   function(x1,x2)

sbplt_3D.scatter(x1, x2, f_anal, c='g', s=40)
sbplt_top.scatter(x1, x2, f_anal, c='g', s=40)
sbplt_front.scatter(x1, x2, f_anal, c='g', s=40)
sbplt_side.scatter(x1, x2, f_anal, c='g', s=40)

#singe sided plus minus 1
diff_int  = 1.
f_sspm1,f1,f2              =   function(x1,x2)
f_sspm1_x1p,f1,f2          =   function(x1+diff_int,x2)
f_sspm1_x2p,f1,f2          =   function(x1,x2+diff_int)

df1_sspm1 = (f_sspm1_x1p - f_sspm1)/diff_int
df2_sspm1 = (f_sspm1_x2p - f_sspm1)/diff_int

sbplt_3D.scatter(x1+diff_int, x2, f_sspm1_x1p, c='r', s=20)
sbplt_3D.scatter(x1, x2+diff_int, f_sspm1_x2p, c='r', s=20)
sbplt_top.scatter(x1+diff_int, x2, f_sspm1_x1p, c='r', s=20)
sbplt_top.scatter(x1, x2+diff_int, f_sspm1_x2p, c='r', s=20)
sbplt_front.scatter(x1+diff_int, x2, f_sspm1_x1p, c='r', s=20)
sbplt_front.scatter(x1, x2+diff_int, f_sspm1_x2p, c='r', s=20)
sbplt_side.scatter(x1+diff_int, x2, f_sspm1_x1p, c='r', s=20)
sbplt_side.scatter(x1, x2+diff_int, f_sspm1_x2p, c='r', s=20)

#singe sided plus minus 0.5
diff_int = .5
f_sspm05,f1,f2             =   function(x1,x2)
f_sspm05_x1p,f1,f2         =   function(x1+diff_int,x2)
f_sspm05_x2p,f1,f2         =   function(x1,x2+diff_int)

df1_sspm05 = (f_sspm05_x1p - f_sspm05)/diff_int
df2_sspm05 = (f_sspm05_x2p - f_sspm05)/diff_int

sbplt_3D.scatter(x1+diff_int, x2, f_sspm05_x1p, c='r', s=20)
sbplt_3D.scatter(x1, x2+diff_int, f_sspm05_x2p, c='r', s=20) 

#singe sided plus minus 0.1
diff_int = .1
f_sspm01,f1,f2             =   function(x1,x2)
f_sspm01_x1p,f1,f2         =   function(x1+diff_int,x2)
f_sspm01_x2p,f1,f2         =   function(x1,x2+diff_int)

df1_sspm01 = (f_sspm01_x1p - f_sspm01)/diff_int
df2_sspm01 = (f_sspm01_x2p - f_sspm01)/diff_int

sbplt_3D.scatter(x1+diff_int, x2, f_sspm01_x1p, c='r', s=20)
sbplt_3D.scatter(x1, x2+diff_int, f_sspm01_x2p, c='r', s=20) 
sbplt_top.scatter(x1+diff_int, x2, f_sspm01_x1p, c='r', s=20)
sbplt_top.scatter(x1, x2+diff_int, f_sspm01_x2p, c='r', s=20)
sbplt_front.scatter(x1+diff_int, x2, f_sspm01_x1p, c='r', s=20)
sbplt_front.scatter(x1, x2+diff_int, f_sspm01_x2p, c='r', s=20)
sbplt_side.scatter(x1+diff_int, x2, f_sspm01_x1p, c='r', s=20)
sbplt_side.scatter(x1, x2+diff_int, f_sspm01_x2p, c='r', s=20)

#singe sided plus minus 0.01
diff_int = .01
f_sspm001,f1,f2             =   function(x1,x2)
f_sspm001_x1p,f1,f2         =   function(x1+diff_int,x2)
f_sspm001_x2p,f1,f2         =   function(x1,x2+diff_int)

df1_sspm001 = (f_sspm001_x1p - f_sspm001)/diff_int
df2_sspm001 = (f_sspm001_x2p - f_sspm001)/diff_int

sbplt_3D.scatter(x1+diff_int, x2, f_sspm001_x1p, c='r', s=20)
sbplt_3D.scatter(x1, x2+diff_int, f_sspm001_x2p, c='r', s=20) 
sbplt_top.scatter(x1+diff_int, x2, f_sspm001_x1p, c='r', s=20)
sbplt_top.scatter(x1, x2+diff_int, f_sspm001_x2p, c='r', s=20) 
sbplt_front.scatter(x1+diff_int, x2, f_sspm001_x1p, c='r', s=20)
sbplt_front.scatter(x1, x2+diff_int, f_sspm001_x2p, c='r', s=20) 
sbplt_side.scatter(x1+diff_int, x2, f_sspm001_x1p, c='r', s=20)
sbplt_side.scatter(x1, x2+diff_int, f_sspm001_x2p, c='r', s=20) 


#central differences plus minus 1
diff_int = 1.
f_cdpm1,f1,f2              =   function(x1,x2)
f_cdpm1_x1p,f1,f2          =   function(x1+diff_int,x2)
f_cdpm1_x1m,f1,f2          =   function(x1-diff_int,x2)
f_cdpm1_x2p,f1,f2          =   function(x1,x2+diff_int)
f_cdpm1_x2m,f1,f2          =   function(x1,x2-diff_int)

df1_cdpm1 = (f_cdpm1_x1p - f_cdpm1_x1m)/(2.*diff_int)
df2_cdpm1 = (f_cdpm1_x2p - f_cdpm1_x2m)/(2.*diff_int)

sbplt_3D.scatter(x1-diff_int, x2, f_cdpm1_x1m, c='r', s=20)
sbplt_3D.scatter(x1, x2-diff_int, f_cdpm1_x2m, c='r', s=20)
sbplt_top.scatter(x1-diff_int, x2, f_cdpm1_x1m, c='r', s=20)
sbplt_top.scatter(x1, x2-diff_int, f_cdpm1_x2m, c='r', s=20)
sbplt_front.scatter(x1-diff_int, x2, f_cdpm1_x1m, c='r', s=20)
sbplt_front.scatter(x1, x2-diff_int, f_cdpm1_x2m, c='r', s=20)
sbplt_side.scatter(x1-diff_int, x2, f_cdpm1_x1m, c='r', s=20)
sbplt_side.scatter(x1, x2-diff_int, f_cdpm1_x2m, c='r', s=20)

#central differences plus minus 0.01
diff_int = 0.01
f_cdpm001,f1,f2              =   function(x1,x2)
f_cdpm001_x1p,f1,f2          =   function(x1+diff_int,x2)
f_cdpm001_x1m,f1,f2          =   function(x1-diff_int,x2)
f_cdpm001_x2p,f1,f2          =   function(x1,x2+diff_int)
f_cdpm001_x2m,f1,f2          =   function(x1,x2-diff_int)

df1_cdpm001 = (f_cdpm001_x1p - f_cdpm001_x1m)/(2.*diff_int)
df2_cdpm001 = (f_cdpm001_x2p - f_cdpm001_x2m)/(2.*diff_int)

sbplt_3D.scatter(x1-diff_int, x2, f_cdpm001_x1m, c='r', s=20)
sbplt_3D.scatter(x1, x2-diff_int, f_cdpm001_x2m, c='r', s=20)
sbplt_top.scatter(x1-diff_int, x2, f_cdpm001_x1m, c='r', s=20)
sbplt_top.scatter(x1, x2-diff_int, f_cdpm001_x2m, c='r', s=20)
sbplt_front.scatter(x1-diff_int, x2, f_cdpm001_x1m, c='r', s=20)
sbplt_front.scatter(x1, x2-diff_int, f_cdpm001_x2m, c='r', s=20)
sbplt_side.scatter(x1-diff_int, x2, f_cdpm001_x1m, c='r', s=20)
sbplt_side.scatter(x1, x2-diff_int, f_cdpm001_x2m, c='r', s=20)

sbplt_3D.set_xlabel('$x_1$')
sbplt_3D.set_ylabel('$x_2$')
sbplt_3D.set_zlabel('$f$')

sbplt_top.set_title('Top')
sbplt_top.set_xlabel('$x_1$')
sbplt_top.set_ylabel('$x_2$')
sbplt_top.set_zlabel('$f$')

sbplt_front.set_title('Front')
sbplt_front.set_xlabel('$x_1$')
sbplt_front.set_ylabel('$x_2$')
sbplt_front.set_zlabel('$f$')

sbplt_side.set_title('Side')
sbplt_side.set_xlabel('$x_1$')
sbplt_side.set_ylabel('$x_2$')
sbplt_side.set_zlabel('$f$')

sbplt_3D.view_init(35, 205)
sbplt_top.view_init(90, 0)
sbplt_front.view_init(0, -90)
sbplt_side.view_init(0, 180)

sbplt_top.set_xticks([])
sbplt_top.set_yticks([])
sbplt_top.set_zticks([])

sbplt_front.set_xticks([])
sbplt_front.set_yticks([])
sbplt_front.set_zticks([])

sbplt_side.set_xticks([])
sbplt_side.set_yticks([])
sbplt_side.set_zticks([])

            
sbplt_3D.set_xlim3d(-2, 2)
sbplt_3D.set_ylim3d(-2, 2)
# sbplt_3D.set_zlim3d(65,105)

sbplt_top.set_xlim3d(-2, 2)
sbplt_top.set_ylim3d(-2, 2)
# sbplt_top.set_zlim3d(65,105)

sbplt_front.set_xlim3d(-2, 2)
sbplt_front.set_ylim3d(-2, 2)
# sbplt_front.set_zlim3d(65,105)

sbplt_side.set_xlim3d(-2, 2)
sbplt_side.set_ylim3d(-2, 2)
# sbplt_side.set_zlim3d(65,105)

sbplt_text.grid(False)
sbplt_text.axis([0, 15, -50, 0])
sbplt_text.set_xticks([])
sbplt_text.set_yticks([])
sbplt_text.set_frame_on(False)
sbplt_text.set_xticklabels((' '))
sbplt_text.set_yticklabels((' '))

#Text
id_name   = -2
id_equal  = 2.3
id_value  = 3.1
id_line   = -30

sbplt_text.text(id_name, id_line, '$f = x_1^2 + 2x_2^2$')
id_line = id_line - 10
sbplt_text.text(id_name , id_line, '$\\bigtriangledown f(x_1,x_2)=[2x_1,4x_2]^T$')
id_line = id_line - 30

sbplt_text.text(id_name, id_line, 'Analyticky')
id_line = id_line - 10
sbplt_text.text(id_name , id_line, '$\\bigtriangledown f($'+str(x1)+','+str(x2)+'$)$')
sbplt_text.text(id_equal, id_line, ' = ')
sbplt_text.text(id_value, id_line, '$[$'+str(df1_anal)+','+str(df2_anal)+'$]^{T}$')

id_line = id_line - 20

sbplt_text.text(id_name, id_line, 'Numericky -- single sided')
id_line = id_line - 10
sbplt_text.text(id_name , id_line, '$\\bigtriangledown f($'+str(x1)+','+str(x2)+'$)$')
sbplt_text.text(id_equal, id_line, ' = ')
sbplt_text.text(id_value, id_line, '$[$'+str(df1_sspm1)+','+str(df2_sspm1)+'$]^{T}$, $[\Delta x_1,\Delta x_2]^T = [1,1]^T$')
id_line = id_line - 10
sbplt_text.text(id_name , id_line, '$\\bigtriangledown f($'+str(x1)+','+str(x2)+'$)$')
sbplt_text.text(id_equal, id_line, ' = ')
sbplt_text.text(id_value, id_line, '$[$'+str(df1_sspm05)+','+str(df2_sspm05)+'$]^{T}$, $[\Delta x_1,\Delta x_2]^T = [0.5,0.5]^T$')
id_line = id_line - 10
sbplt_text.text(id_name , id_line, '$\\bigtriangledown f($'+str(x1)+','+str(x2)+'$)$')
sbplt_text.text(id_equal, id_line, ' = ')
sbplt_text.text(id_value, id_line, '$[$'+str(df1_sspm01)+','+str(df2_sspm01)+'$]^{T}$, $[\Delta x_1,\Delta x_2]^T = [0.1,0.1]^T$')
id_line = id_line - 10
sbplt_text.text(id_name , id_line, '$\\bigtriangledown f($'+str(x1)+','+str(x2)+'$)$')
sbplt_text.text(id_equal, id_line, ' = ')
sbplt_text.text(id_value, id_line, '$[$'+str(df1_sspm001)+','+str(df2_sspm001)+'$]^{T}$, $[\Delta x_1,\Delta x_2]^T = [0.01,0.01]^T$')

id_line = id_line - 20

sbplt_text.text(id_name, id_line, 'Numericky -- central differences')
id_line = id_line - 10
sbplt_text.text(id_name , id_line, '$\\bigtriangledown f($'+str(x1)+','+str(x2)+'$)$')
sbplt_text.text(id_equal, id_line, ' = ')
sbplt_text.text(id_value, id_line, '$[$'+str(df1_cdpm1)+','+str(df2_cdpm1)+'$]^{T}$, $[\Delta x_1,\Delta x_2]^T = [1,1]^T$')                            
id_line = id_line - 10
sbplt_text.text(id_name , id_line, '$\\bigtriangledown f($'+str(x1)+','+str(x2)+'$)$')
sbplt_text.text(id_equal, id_line, ' = ')
sbplt_text.text(id_value, id_line, '$[$'+str(df1_cdpm001)+','+str(df2_cdpm001)+'$]^{T}$, $[\Delta x_1,\Delta x_2]^T = [0.01,0.01]^T$')  

plt.savefig('gradient_ukazka.pdf', format='pdf')


# plt.show()