from datetime import datetime
from mpl_toolkits.mplot3d import Axes3D
from matplotlib import rcParams
rcParams['font.family'] = 'serif'
rcParams['font.sans-serif'] = 'Times'
rcParams['font.size'] = 10
from matplotlib import cm
from matplotlib.ticker import LinearLocator,ScalarFormatter, FormatStrFormatter, MaxNLocator
import matplotlib.pyplot as plt
import matplotlib.gridspec as gridspec

import shutil

from function_3 import *
# from function_1 import *

#FUNCTIONS#######################################

def ensure_dir(f):
    if not os.path.exists(f):
        os.makedirs(f)

#FUNCTIONS#######################################

x           =   arange(-20.0, 20.0, 1)
y           =   arange(-20.0, 20.0, 1)

x, y        =   meshgrid(x, y)

r           =   function(x,y)         

ms_1        =   3
ms_2        =   5

plt.figure()
plt.subplots_adjust(hspace=0.2,wspace=0.5)

sbplt_3D    = plt.subplot2grid((4,4),(0,0), colspan=3, rowspan=3, projection='3d')
sbplt_top   = plt.subplot2grid((4,4),(0,3), colspan=1, rowspan=1, projection='3d')
sbplt_front = plt.subplot2grid((4,4),(1,3), colspan=1, rowspan=1, projection='3d')
sbplt_side  = plt.subplot2grid((4,4),(2,3), colspan=1, rowspan=1, projection='3d')
sbplt_obj   = plt.subplot2grid((4,4),(3,0), colspan=2, rowspan=1)
sbplt_x     = plt.subplot2grid((4,4),(3,2), colspan=1, rowspan=1)
sbplt_y     = plt.subplot2grid((4,4),(3,3), colspan=1, rowspan=1)
    
sbplt_3D.plot_surface(x,y,r,rstride=1,cstride=1,linewidth=0,cmap=cm.coolwarm,alpha=0.4)
sbplt_top.plot_surface(x,y,r,rstride=1,cstride=1,linewidth=0,cmap=cm.coolwarm,alpha=0.5)
sbplt_front.plot_surface(x,y,r,rstride=1,cstride=1,linewidth=0,cmap=cm.coolwarm,alpha=0.5)
sbplt_side.plot_surface(x,y,r,rstride=1,cstride=1,linewidth=0,cmap=cm.coolwarm,alpha=0.5) 

sbplt_3D.set_xlabel('$x$')
sbplt_3D.set_ylabel('$y$')
sbplt_3D.set_zlabel('$r$')

sbplt_top.set_title('Top')
sbplt_top.set_xlabel('$x$')
sbplt_top.set_ylabel('$y$')
sbplt_top.set_zlabel('$r$')

sbplt_front.set_title('Front')
sbplt_front.set_xlabel('$x$')
sbplt_front.set_ylabel('$y$')
sbplt_front.set_zlabel('$r$')

sbplt_side.set_title('Side')
sbplt_side.set_xlabel('$x$')
sbplt_side.set_ylabel('$y$')
sbplt_side.set_zlabel('$r$')

sbplt_obj.set_xlabel('Design no.')
sbplt_obj.set_ylabel('$r$')
sbplt_obj.grid(True)

sbplt_x.set_xlabel('Design no.')
sbplt_x.set_ylabel('$x$')
sbplt_x.grid(True)

sbplt_y.set_xlabel('Design no.')
sbplt_y.set_ylabel('$y$')
sbplt_y.grid(True)

sbplt_3D.view_init(35, 205)
sbplt_top.view_init(90, 0)
sbplt_front.view_init(0, -90)
sbplt_side.view_init(0, 180)

sbplt_top.set_xticks([])
sbplt_top.set_yticks([])
sbplt_top.set_zticks([])

sbplt_front.set_xticks([])
sbplt_front.set_yticks([])
sbplt_front.set_zticks([])

sbplt_side.set_xticks([])
sbplt_side.set_yticks([])
sbplt_side.set_zticks([])


#Animation#############

name_opti   =   'function_1_GA_NOA'

anim_dir    =   os.path.join(os.getcwd(),'animations')
anim_dir    =   os.path.join(anim_dir,name_opti)

ensure_dir(anim_dir)

opti_dir    =   os.path.join(os.getcwd(),name_opti)

minimum_r   = 1.0e64
minimum_x   = []
minimum_y   = []

celkem_pocet_designu   =   0

for dirname, dirnames, filenames in os.walk(opti_dir):

    for subdirname in dirnames:

        subdir_path             =  os.path.join(dirname,subdirname)
        filename_file_input     =  os.path.join(subdir_path,'input.txt')
        filename_file_output    =  os.path.join(subdir_path,'output.txt')
        filename_figure         =  os.path.join(subdir_path,'figure.png')

        if os.path.exists(filename_file_input) and os.path.exists(filename_file_output) and ('Design' in subdirname):
        
            celkem_pocet_designu   =   celkem_pocet_designu + 1 

x_min   = -1
y_min   = 4
obj_min = function(x_min,y_min)

sbplt_obj.plot([0,celkem_pocet_designu],[obj_min,obj_min],'g')
sbplt_x.plot([0,celkem_pocet_designu],[x_min,x_min],'g')
sbplt_y.plot([0,celkem_pocet_designu],[y_min,y_min],'g')

Design      = 0
for dirname, dirnames, filenames in os.walk(opti_dir):

    for subdirname in dirnames:

        subdir_path             =  os.path.join(dirname,subdirname)
        filename_file_input     =  os.path.join(subdir_path,'input.txt')
        filename_file_output    =  os.path.join(subdir_path,'output.txt')
        filename_figure         =  os.path.join(subdir_path,'figure.png')

        if os.path.exists(filename_file_input) and os.path.exists(filename_file_output) and ('Design' in subdirname):
            
            Design      = Design + 1
            
            destination = os.path.join(anim_dir,subdirname+'.png')
            
            xy          = function_variable_read_from_file(filename_file_input)
            r           = function_variable_read_from_file(filename_file_output)

            if minimum_r>r:

                try:
                    sbplt_3D_min
                except NameError:
                    sbplt_3D_min    = sbplt_3D.scatter(xy[0], xy[1], r, c='g', s=20)
                else:
                    sbplt_3D_min.remove()
                    sbplt_3D.scatter(minimum_x, minimum_y, minimum_r, c='r', s=20)
                    sbplt_3D_min    = sbplt_3D.scatter(xy[0], xy[1], r, c='g', s=20)
    
                try:
                    sbplt_top_min
                except NameError:
                    sbplt_top_min   = sbplt_top.scatter(xy[0], xy[1], 101, c='g', s=10)
                else:
                    sbplt_top_min.remove()                
                    sbplt_top.scatter(minimum_x, minimum_y, 100, c='r', s=10)
                    sbplt_top_min   = sbplt_top.scatter(xy[0], xy[1], 101, c='g', s=10)
                    
                try:
                    sbplt_front_min
                except NameError:
                    sbplt_front_min = sbplt_front.scatter(xy[0], -21, r, c='g', s=10)
                else:
                    sbplt_front_min.remove()
                    sbplt_front.scatter(minimum_x, -20, minimum_r, c='r', s=10)
                    sbplt_front_min = sbplt_front.scatter(xy[0], -21, r, c='g', s=10)
                    
                try:
                    sbplt_side_min
                except NameError:
                    sbplt_side_min  = sbplt_side.scatter(-21, xy[1], r, c='g', s=10)
                else:
                    sbplt_side_min.remove()                                
                    sbplt_side.scatter(-20, minimum_y, minimum_r, c='r', s=10)
                    sbplt_side_min  = sbplt_side.scatter(-21, xy[1], r, c='g', s=10)

                try:
                    sbplt_obj_min
                except NameError:
                    sbplt_obj_min  = sbplt_obj.plot(Design, r, 'go',ms=ms_1)
                else:
                    sbplt_obj_min.pop(0).remove()                                
                    sbplt_obj.plot(minimum_D, minimum_r, 'ro',ms=ms_1)
                    sbplt_obj_min  = sbplt_obj.plot(Design, r, 'go',ms=ms_1)

                try:
                    sbplt_x_min
                except NameError:
                    sbplt_x_min  = sbplt_x.plot(Design, xy[0], 'go',ms=ms_1)
                else:
                    sbplt_x_min.pop(0).remove()                                
                    sbplt_x.plot(minimum_D, minimum_x, 'ro',ms=ms_1)
                    sbplt_x_min  = sbplt_x.plot(Design, xy[0], 'go',ms=ms_1)

                try:
                    sbplt_y_min
                except NameError:
                    sbplt_y_min  = sbplt_y.plot(Design, xy[1], 'go',ms=ms_1)
                else:
                    sbplt_y_min.pop(0).remove()                                
                    sbplt_y.plot(minimum_D, minimum_y, 'ro',ms=ms_1)
                    sbplt_y_min  = sbplt_y.plot(Design, xy[1], 'go',ms=ms_1)
                
                minimum_r   = r
                minimum_x   = xy[0]
                minimum_y   = xy[1]
                minimum_D   = Design
                
            else:
            
                sbplt_3D.scatter(xy[0], xy[1], r, c='r', s=20)

                sbplt_top.scatter(xy[0], xy[1], 100, c='r', s=10)
                sbplt_front.scatter(xy[0], -20, r, c='r', s=10)
                sbplt_side.scatter(-20, xy[1], r, c='r', s=10)            

                sbplt_obj.plot(Design, r, 'ro',ms=ms_1)
                sbplt_x.plot(Design, xy[0], 'ro',ms=ms_1)
                sbplt_y.plot(Design, xy[1], 'ro',ms=ms_1)
            
            sbplt_3D.set_xlim3d(-20, 20)
            sbplt_3D.set_ylim3d(-20, 20)
            sbplt_3D.set_zlim3d(65,105)
#             sbplt_3D.set_zlim3d(0,105)
            
            sbplt_top.set_xlim3d(-20, 20)
            sbplt_top.set_ylim3d(-20, 20)
            sbplt_top.set_zlim3d(65,105)
#             sbplt_top.set_zlim3d(0,105)
            
            sbplt_front.set_xlim3d(-20, 20)
            sbplt_front.set_ylim3d(-20, 20)
            sbplt_front.set_zlim3d(65,105)
#             sbplt_front.set_zlim3d(0,105)
            
            sbplt_side.set_xlim3d(-20, 20)
            sbplt_side.set_ylim3d(-20, 20)
            sbplt_side.set_zlim3d(65,105)
#             sbplt_side.set_zlim3d(0,105)                                                
            
            sbplt_obj.axis([0,celkem_pocet_designu,65,105])
            sbplt_x.axis([0,celkem_pocet_designu,-20,20])
            sbplt_y.axis([0,celkem_pocet_designu,-20,20])
            
            plt.savefig(filename_figure, dpi=300, format='png')
            
            print 'Directory ',subdir_path,' -> ',destination
            shutil.copy(filename_figure, destination)


# plt.show()