import matplotlib.pyplot as plt
import numpy as np

data = ((3, 2.5), (6, 2.), (9, 1.), (12, 1.5))
d = np.array([di[1] for di in data])
Nu = 14
A = np.zeros((len(data), Nu))
A[0, 2] = 1
A[1, 5] = 1
A[2, 8] = 1
A[3, 11] = 1

def Au(u):
    r = d - np.dot(A, u)
    return np.dot(r.T, r)

def Hdef0():
    Hdef = np.zeros(Nu)
    Hwidth = 2
    for ii in range(min(Hwidth, Nu)):
        Hdef = Hdef + (-1.) ** ii / max(1, ii) * (
            np.eye(Nu, k = ii) +
            np.eye(Nu, k = -ii))
    Hdef[0, 0] = 1
    Hdef[-1, -1] = 1
    return Hdef

def Hdef1():
    D = np.zeros((Nu-2, Nu))
    for ii in range(D.shape[0]):
        D[ii, ii] = -1
        D[ii, ii+1] = 2
        D[ii, ii+2] = -1
    return np.dot(D.T, D)

Hdef = Hdef1()
print 'Hdef =\n', Hdef
print '|Hdef| =', np.linalg.det(Hdef)

def Bu(u, H = Hdef):
    return np.dot(u.T, np.dot(H, u))

from scipy.optimize import minimize

ui = []
fi = []
x0 = np.ones(Nu)

gamma = (.1, 1., 10, 100) #np.linspace(0, 1, 11)[1:]

for gi in gamma:
    #soli = minimize(
    #    lambda u: Au(u) + gi * Bu(u),
    #    x0)
    usol = np.linalg.solve(
        np.dot(A.T, A) + gi * Hdef,
        np.dot(A.T, d))

    #ui.append(soli.x)
    ui.append(usol)
    #fi.append(soli.fun)
    fi.append(Au(usol) + gi * Bu(usol))

print ui
print fi

for ii, u in enumerate(ui):
    plt.plot(np.arange(len(u)) + 1, u, label = '$\gamma = %f$' % gamma[ii])
plt.plot([di[0] for di in data], [di[1] for di in data], 'or')
plt.legend(loc = 'best')
plt.xlabel('$i$')
plt.ylabel('$u_i$')
plt.grid()

plt.figure()
plt.plot(gamma, fi)
plt.xlabel('$\gamma$')
plt.ylabel('$f(u)$')

plt.show()
